;	ORG $1001-2
;	DW  $1001
;	
;	DW nextln,0	; second word is line number
;	DB $9E
;	if hide > 9999
;	DB "0"+hide/10000
;	endif
;	DB "0"+(hide/1000)%10,"0"+(hide/100)%10,"0"+(hide/10)%10,"0"+hide%10,0
;nextln	DB 0,0

ptr	= $D0
chr	= $D2
count	= $D4
	
hide
	;SEI
	;STA $FF3F
	;
;	LDX #$00
;xx1	TXA
;	STA $0d00,x
;	LDA $FF00
;	STA $0900,x
;	INX
;	BNE xx1
	;
	; ---
	;
	LDY #$00
	STY ptr
	STY ptr+2
	;
	LDA $FF13	; get address of current charset
	AND #$FC	; allow for 256 or 128 char modes
	STA ptr+1
	LDA #$58
	STA ptr+3
	;
	LDA #$CB
	JSR hsync
	STA $FF3E
	;
	LDX #$03
hcopy1	LDA (ptr),y
	STA (ptr+2),y
	INY
	BNE hcopy1
	;
	INC ptr+1
	INC ptr+3	
	DEX
	BPL hcopy1
	;
	STA $FF3F
	;
	; ---
	;
	LDX #$00
	LDA $FF07	; check for invert flag
	AND #$80	; if $FF07/$80 is set, then we have 256 mode
	BNE h_noinv	; means no invert
	;
	LDA ptr+1	; otherwise invert, so set back charset ptr by $400 bytes
	SEC
	SBC #$04
	STA ptr+1
	;
	LDX #$FF	; and EOR all chars with $FF to invert them
	;
h_noinv	STX h_inv+1
	;
	; ---
	;
	LDA #$CB
	JSR hsync
	STA $FF3E
	;
	LDX #$03
hcopy2	LDA (ptr),y
h_inv	EOR #$FF
	STA (ptr+2),y
	INY
	BNE hcopy2
	;
	INC ptr+1
	INC ptr+3	
	DEX
	BPL hcopy2
	;
	STA $FF3F
	;
	; ---
	;
	LDA $FF12	; set up our new charset
	AND #$03
	STA $FF12
	LDA #$58
	STA $FF13
	;
	; ---
	;
	LDY #$00
	STY ptr
	STY count
	STY count+1
	;
	LDA #$0C
	STA ptr+1
	;
	LDX #$17
	LDA #$20
h0	STA $0FE8,x	; clear the last 18 bytes (off screen)
	DEX		; to avoid counting those as non-spaces
	BPL h0
	;
	; ---
	;
	LDX #$03
	;
h2	LDA (ptr),y
	CMP #$20	; count non-spaces
	BEQ h1
	;
	CMP #$40	; convert $40 to $43 (same looking char)
	BNE h1b
	;
	LDA #$43
	STA (ptr),y
	;
h1b	CMP #$C0	; and $C0 to $C3
	BNE h1c
	;
	LDA #$C3
	STA (ptr),y
	;	
h1c	INC count	; found one, increment counter
	BNE *+4
	INC count+1
	;
h1	INY
	BNE h2
	;
	INC ptr+1
	DEX
	BPL h2
	;
	; ---
	;
hmain	LDA count	; any more chars left? 16 bit zero check
	ORA count+1
	BNE hnotdone
	JMP hdone     
	;
hnotdone
	LDA $FF00
	ORA #$01
	CLC
	ADC ptr
hinc	STA ptr
	LDA ptr+1
	ADC #$00
	AND #$03
	ORA #$0C
	STA ptr+1
	;
	LDY #$00
	LDA (ptr),y
	CMP #$20
	BNE hfound
	;
	LDA ptr
	CLC
	ADC #$05
	JMP hinc
	;
hfound	STA chr
	LDA #$00
	STA chr+1
	;
	ASL chr
	ROL chr+1
	ASL chr
	ROL chr+1
	ASL chr
	ROL chr+1
	;
	LDA chr+1
	ORA #$58
	STA chr+1
	;
	LDY #$07
hcopy3	LDA (chr),y
	STA $5800+$0200,y
	DEY
	BPL hcopy3
	;
	LDY #$00
	LDA #$40
	STA (ptr),y		; put our special char there
	;
	; ---
	;
	LDA hlr
	EOR #$40
	STA hlr
	JMP hx3			; skip the first sync
	;
hx2	LDA #$CB
	JSR hsync
	;
hx3	LDY #$05		; move everything down by two lines
hx1	LDA $5800+$0200,y
hlr	ASL a			; shift left/right
	STA $5802+$0200,y
	DEY
	BPL hx1
	;
	LDA #$00
	STA $5800+$0200		; clear the first line
	STA $5801+$0200		; clear the first line
	;
	LDA $5802+$0200		; anything left?
	ORA $5803+$0200
	ORA $5804+$0200
	ORA $5805+$0200
	ORA $5806+$0200
	ORA $5807+$0200
	BNE hx2
	;
	LDY #$00
	LDA #$20
	STA (ptr),y
	;
	LDA count
	SEC
	SBC #$01
	STA count
	LDA count+1
	SBC #$00
	STA count+1
	;
	JMP hmain
	;
hdone	
	;STA $FF3E
	;CLI
	;
	LDX #$FF
	LDA $FF07
	AND #$40
	BEQ pal
	LDX #$F7
pal	TXA
	JSR hsync
	JSR hsync
	;
	LDY #$04
h12	LDA $FF15,y
	AND #$7F
	CLC
	ADC #$10
	BPL h11
	LDA #$71
h11	STA $FF15,y
	DEY
	BPL h12
	;
	LDY #$04
h13	LDA $FF15,y
	CMP #$F1
	BNE pal
	DEY
	BPL h13
	;
	RTS

hsync
hx4	CMP $FF1D
	BNE hx4
hx5	CMP $FF1D
	BEQ hx5
	RTS
;[eof]